---
title: Delete Key Rotation Policy
description: The DEL /environments/{{envID}}/keyRotationPolicies/{{krpID}} operation deletes the specified key rotation policy in the environment. You cannot delete the default KRP for an environment. A DELETE operation won't succeed if the environment has only one KRP.
component: pingone-api
page_id: pingone-api:platform:certificate-management/key-rotation-policies/delete-key-rotation-policy
canonical_url: https://developer.pingidentity.com/pingone-api/platform/certificate-management/key-rotation-policies/delete-key-rotation-policy.html
section_ids:
  headers: Headers
  example-request: Example Request
  example-response: Example Response
---

# Delete Key Rotation Policy

##

```none
DELETE {{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}
```

The `DEL /environments/{{envID}}/keyRotationPolicies/{{krpID}}` operation deletes the specified key rotation policy in the environment. You cannot delete the default KRP for an environment. A DELETE operation won't succeed if the environment has only one KRP.

|   |                                                                                                                                                   |
| - | ------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | The key rotation policy must not be associated with any applications. If the key rotation policy is used by an application, it cannot be deleted. |

When successful, the `DELETE` request returns a `202 Accepted` message with the key rotation policy ID in the response body.

### Headers

Authorization      Bearer {{accessToken}}

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request DELETE '{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}' \
--header 'Authorization: Bearer {{accessToken}}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Delete);
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}"
  method := "DELETE"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
DELETE /v1/environments/{{envID}}/keyRotationPolicies/{{krpID}} HTTP/1.1
Host: {{apiPath}}
Authorization: Bearer {{accessToken}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}")
  .method("DELETE", body)
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}",
  "method": "DELETE",
  "timeout": 0,
  "headers": {
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'DELETE',
  'url': '{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}',
  'headers': {
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}"

payload = {}
headers = {
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("DELETE", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}');
$request->setMethod(HTTP_Request2::METHOD_DELETE);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Delete.new(url)
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/keyRotationPolicies/{{krpID}}")!,timeoutInterval: Double.infinity)
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "DELETE"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

202 Accepted

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/keyRotationPolicies/7710c674-1751-443a-9568-78943c16324b"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "7710c674-1751-443a-9568-78943c16324b",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "name": "Test Key Rotation Policy",
    "usageType": "SIGNING",
    "default": false,
    "dn": "CN=Test Key Rotation Policy, OU=Ping Identity, O=Ping Identity, L=, ST=, C=US",
    "algorithm": "RSA",
    "keyLength": 2048,
    "validityPeriod": 365,
    "signatureAlgorithm": "SHA256withRSA",
    "rotationPeriod": 120,
    "currentKeyId": "2ad7f810-9452-11ee-b003-6bd4f5a214b0",
    "nextKeyId": "2b0103e0-9452-11ee-b003-6bd4f5a214b0",
    "rotatedAt": "2023-12-06T16:11:52.019Z"
}
```
